// Code generated by dagger-compiler.  Do not edit.
package feign;


import dagger.internal.Binding;
import dagger.internal.Linker;
import dagger.internal.ModuleAdapter;
import java.util.Map;
import java.util.Set;
import javax.inject.Provider;

/**
 * A manager of modules and provides adapters allowing for proper linking and
 * instance provision of types served by {@code @Provides} methods.
 */
public final class Feign$Defaults$$ModuleAdapter extends ModuleAdapter<Feign.Defaults> {
  private static final String[] INJECTS = { "members/feign.Feign", };
  private static final Class<?>[] STATIC_INJECTIONS = { };
  private static final Class<?>[] INCLUDES = { };

  public Feign$Defaults$$ModuleAdapter() {
    super(INJECTS, STATIC_INJECTIONS, false /*overrides*/, INCLUDES, false /*complete*/, true /*library*/);
  }

  @Override
  public Feign.Defaults newModule() {
    return new feign.Feign.Defaults();
  }

  /**
   * Used internally obtain dependency information, such as for cyclical
   * graph detection.
   */
  @Override
  public void getBindings(Map<String, Binding<?>> map) {
    map.put("feign.Logger$Level", new LogLevelProvidesAdapter(module));
    map.put("feign.Contract", new ContractProvidesAdapter(module));
    map.put("javax.net.ssl.SSLSocketFactory", new SslSocketFactoryProvidesAdapter(module));
    map.put("feign.Client", new HttpClientProvidesAdapter(module));
    map.put("feign.Retryer", new RetryerProvidesAdapter(module));
    map.put("feign.Logger", new NoOpProvidesAdapter(module));
    map.put("feign.codec.ErrorDecoder", new ErrorDecoderProvidesAdapter(module));
    map.put("feign.Request$Options", new OptionsProvidesAdapter(module));
    map.put("java.util.Set<feign.codec.Encoder>", new NoEncodersProvidesAdapter(module));
    map.put("java.util.Set<feign.codec.Decoder>", new NoDecodersProvidesAdapter(module));
    map.put("java.util.Set<feign.codec.IncrementalDecoder>", new NoIncrementalDecodersProvidesAdapter(module));
    map.put("@javax.inject.Named(value=http)/java.util.concurrent.Executor", new HttpExecutorProvidesAdapter(module));
  }

  /**
   * A {@code Binder<feign.Logger.Level>} implementation which satisfies
   * Dagger's infrastructure requirements including:
   * 
   * Being a {@code Provider<feign.Logger.Level>} and handling creation and
   * preparation of object instances.
   */
  public static final class LogLevelProvidesAdapter extends Binding<Logger.Level>
      implements Provider<Logger.Level> {
    private final Feign.Defaults module;

    public LogLevelProvidesAdapter(Feign.Defaults module) {
      super("feign.Logger$Level", null, NOT_SINGLETON, "feign.Feign.Defaults.logLevel()");
      this.module = module;
      setLibrary(true);
    }

    /**
     * Returns the fully provisioned instance satisfying the contract for
     * {@code Provider<feign.Logger.Level>}.
     */
    @Override
    public Logger.Level get() {
      return module.logLevel();
    }
  }

  /**
   * A {@code Binder<feign.Contract>} implementation which satisfies
   * Dagger's infrastructure requirements including:
   * 
   * Being a {@code Provider<feign.Contract>} and handling creation and
   * preparation of object instances.
   */
  public static final class ContractProvidesAdapter extends Binding<Contract>
      implements Provider<Contract> {
    private final Feign.Defaults module;

    public ContractProvidesAdapter(Feign.Defaults module) {
      super("feign.Contract", null, NOT_SINGLETON, "feign.Feign.Defaults.contract()");
      this.module = module;
      setLibrary(true);
    }

    /**
     * Returns the fully provisioned instance satisfying the contract for
     * {@code Provider<feign.Contract>}.
     */
    @Override
    public Contract get() {
      return module.contract();
    }
  }

  /**
   * A {@code Binder<javax.net.ssl.SSLSocketFactory>} implementation which satisfies
   * Dagger's infrastructure requirements including:
   * 
   * Being a {@code Provider<javax.net.ssl.SSLSocketFactory>} and handling creation and
   * preparation of object instances.
   */
  public static final class SslSocketFactoryProvidesAdapter extends Binding<javax.net.ssl.SSLSocketFactory>
      implements Provider<javax.net.ssl.SSLSocketFactory> {
    private final Feign.Defaults module;

    public SslSocketFactoryProvidesAdapter(Feign.Defaults module) {
      super("javax.net.ssl.SSLSocketFactory", null, NOT_SINGLETON, "feign.Feign.Defaults.sslSocketFactory()");
      this.module = module;
      setLibrary(true);
    }

    /**
     * Returns the fully provisioned instance satisfying the contract for
     * {@code Provider<javax.net.ssl.SSLSocketFactory>}.
     */
    @Override
    public javax.net.ssl.SSLSocketFactory get() {
      return module.sslSocketFactory();
    }
  }

  /**
   * A {@code Binder<feign.Client>} implementation which satisfies
   * Dagger's infrastructure requirements including:
   * 
   * Owning the dependency links between {@code feign.Client} and its
   * dependencies.
   * 
   * Being a {@code Provider<feign.Client>} and handling creation and
   * preparation of object instances.
   */
  public static final class HttpClientProvidesAdapter extends Binding<Client>
      implements Provider<Client> {
    private final Feign.Defaults module;
    private Binding<Client.Default> client;

    public HttpClientProvidesAdapter(Feign.Defaults module) {
      super("feign.Client", null, NOT_SINGLETON, "feign.Feign.Defaults.httpClient()");
      this.module = module;
      setLibrary(true);
    }

    /**
     * Used internally to link bindings/providers together at run time
     * according to their dependency graph.
     */
    @Override
    @SuppressWarnings("unchecked")
    public void attach(Linker linker) {
      client = (Binding<Client.Default>) linker.requestBinding("feign.Client$Default", Feign.Defaults.class, getClass().getClassLoader());
    }

    /**
     * Used internally obtain dependency information, such as for cyclical
     * graph detection.
     */
    @Override
    public void getDependencies(Set<Binding<?>> getBindings, Set<Binding<?>> injectMembersBindings) {
      getBindings.add(client);
    }

    /**
     * Returns the fully provisioned instance satisfying the contract for
     * {@code Provider<feign.Client>}.
     */
    @Override
    public Client get() {
      return module.httpClient(client.get());
    }
  }

  /**
   * A {@code Binder<feign.Retryer>} implementation which satisfies
   * Dagger's infrastructure requirements including:
   * 
   * Being a {@code Provider<feign.Retryer>} and handling creation and
   * preparation of object instances.
   */
  public static final class RetryerProvidesAdapter extends Binding<Retryer>
      implements Provider<Retryer> {
    private final Feign.Defaults module;

    public RetryerProvidesAdapter(Feign.Defaults module) {
      super("feign.Retryer", null, NOT_SINGLETON, "feign.Feign.Defaults.retryer()");
      this.module = module;
      setLibrary(true);
    }

    /**
     * Returns the fully provisioned instance satisfying the contract for
     * {@code Provider<feign.Retryer>}.
     */
    @Override
    public Retryer get() {
      return module.retryer();
    }
  }

  /**
   * A {@code Binder<feign.Logger>} implementation which satisfies
   * Dagger's infrastructure requirements including:
   * 
   * Being a {@code Provider<feign.Logger>} and handling creation and
   * preparation of object instances.
   */
  public static final class NoOpProvidesAdapter extends Binding<Logger>
      implements Provider<Logger> {
    private final Feign.Defaults module;

    public NoOpProvidesAdapter(Feign.Defaults module) {
      super("feign.Logger", null, NOT_SINGLETON, "feign.Feign.Defaults.noOp()");
      this.module = module;
      setLibrary(true);
    }

    /**
     * Returns the fully provisioned instance satisfying the contract for
     * {@code Provider<feign.Logger>}.
     */
    @Override
    public Logger get() {
      return module.noOp();
    }
  }

  /**
   * A {@code Binder<feign.codec.ErrorDecoder>} implementation which satisfies
   * Dagger's infrastructure requirements including:
   * 
   * Being a {@code Provider<feign.codec.ErrorDecoder>} and handling creation and
   * preparation of object instances.
   */
  public static final class ErrorDecoderProvidesAdapter extends Binding<feign.codec.ErrorDecoder>
      implements Provider<feign.codec.ErrorDecoder> {
    private final Feign.Defaults module;

    public ErrorDecoderProvidesAdapter(Feign.Defaults module) {
      super("feign.codec.ErrorDecoder", null, NOT_SINGLETON, "feign.Feign.Defaults.errorDecoder()");
      this.module = module;
      setLibrary(true);
    }

    /**
     * Returns the fully provisioned instance satisfying the contract for
     * {@code Provider<feign.codec.ErrorDecoder>}.
     */
    @Override
    public feign.codec.ErrorDecoder get() {
      return module.errorDecoder();
    }
  }

  /**
   * A {@code Binder<feign.Request.Options>} implementation which satisfies
   * Dagger's infrastructure requirements including:
   * 
   * Being a {@code Provider<feign.Request.Options>} and handling creation and
   * preparation of object instances.
   */
  public static final class OptionsProvidesAdapter extends Binding<Request.Options>
      implements Provider<Request.Options> {
    private final Feign.Defaults module;

    public OptionsProvidesAdapter(Feign.Defaults module) {
      super("feign.Request$Options", null, NOT_SINGLETON, "feign.Feign.Defaults.options()");
      this.module = module;
      setLibrary(true);
    }

    /**
     * Returns the fully provisioned instance satisfying the contract for
     * {@code Provider<feign.Request.Options>}.
     */
    @Override
    public Request.Options get() {
      return module.options();
    }
  }

  /**
   * A {@code Binder<java.util.Set<feign.codec.Encoder>>} implementation which satisfies
   * Dagger's infrastructure requirements including:
   * 
   * Being a {@code Provider<java.util.Set<feign.codec.Encoder>>} and handling creation and
   * preparation of object instances.
   */
  public static final class NoEncodersProvidesAdapter extends Binding<Set<feign.codec.Encoder>>
      implements Provider<Set<feign.codec.Encoder>> {
    private final Feign.Defaults module;

    public NoEncodersProvidesAdapter(Feign.Defaults module) {
      super("java.util.Set<feign.codec.Encoder>", null, NOT_SINGLETON, "feign.Feign.Defaults.noEncoders()");
      this.module = module;
      setLibrary(true);
    }

    /**
     * Returns the fully provisioned instance satisfying the contract for
     * {@code Provider<java.util.Set<feign.codec.Encoder>>}.
     */
    @Override
    public Set<feign.codec.Encoder> get() {
      return module.noEncoders();
    }
  }

  /**
   * A {@code Binder<java.util.Set<feign.codec.Decoder>>} implementation which satisfies
   * Dagger's infrastructure requirements including:
   * 
   * Being a {@code Provider<java.util.Set<feign.codec.Decoder>>} and handling creation and
   * preparation of object instances.
   */
  public static final class NoDecodersProvidesAdapter extends Binding<Set<feign.codec.Decoder>>
      implements Provider<Set<feign.codec.Decoder>> {
    private final Feign.Defaults module;

    public NoDecodersProvidesAdapter(Feign.Defaults module) {
      super("java.util.Set<feign.codec.Decoder>", null, NOT_SINGLETON, "feign.Feign.Defaults.noDecoders()");
      this.module = module;
      setLibrary(true);
    }

    /**
     * Returns the fully provisioned instance satisfying the contract for
     * {@code Provider<java.util.Set<feign.codec.Decoder>>}.
     */
    @Override
    public Set<feign.codec.Decoder> get() {
      return module.noDecoders();
    }
  }

  /**
   * A {@code Binder<java.util.Set<feign.codec.IncrementalDecoder>>} implementation which satisfies
   * Dagger's infrastructure requirements including:
   * 
   * Being a {@code Provider<java.util.Set<feign.codec.IncrementalDecoder>>} and handling creation and
   * preparation of object instances.
   */
  public static final class NoIncrementalDecodersProvidesAdapter extends Binding<Set<feign.codec.IncrementalDecoder>>
      implements Provider<Set<feign.codec.IncrementalDecoder>> {
    private final Feign.Defaults module;

    public NoIncrementalDecodersProvidesAdapter(Feign.Defaults module) {
      super("java.util.Set<feign.codec.IncrementalDecoder>", null, NOT_SINGLETON, "feign.Feign.Defaults.noIncrementalDecoders()");
      this.module = module;
      setLibrary(true);
    }

    /**
     * Returns the fully provisioned instance satisfying the contract for
     * {@code Provider<java.util.Set<feign.codec.IncrementalDecoder>>}.
     */
    @Override
    public Set<feign.codec.IncrementalDecoder> get() {
      return module.noIncrementalDecoders();
    }
  }

  /**
   * A {@code Binder<java.util.concurrent.Executor>} implementation which satisfies
   * Dagger's infrastructure requirements including:
   * 
   * Being a {@code Provider<java.util.concurrent.Executor>} and handling creation and
   * preparation of object instances.
   */
  public static final class HttpExecutorProvidesAdapter extends Binding<java.util.concurrent.Executor>
      implements Provider<java.util.concurrent.Executor> {
    private final Feign.Defaults module;

    public HttpExecutorProvidesAdapter(Feign.Defaults module) {
      super("@javax.inject.Named(value=http)/java.util.concurrent.Executor", null, IS_SINGLETON, "feign.Feign.Defaults.httpExecutor()");
      this.module = module;
      setLibrary(true);
    }

    /**
     * Returns the fully provisioned instance satisfying the contract for
     * {@code Provider<java.util.concurrent.Executor>}.
     */
    @Override
    public java.util.concurrent.Executor get() {
      return module.httpExecutor();
    }
  }
}
